/*
 * Copyright (C) 2012-2013
 * Modifications 10/16/2013 by Brian Thurlow
 */

/***#################### IOS BILLING ##################***/
var IAP = {
    list: [ 'my_first_product', 'my_second_product' ],
    products: {}
};
var localStorage = window.localStorage || {};

IAP.initialize = function () {
    // Check availability of the storekit plugin
	
	//alert('OKOOK');
	
    if (!window.storekit) {
        console.log('In-App Purchases not available');
        return;
    }

    // Initialize
    storekit.init({
        ready:    IAP.onReady,
        purchase: IAP.onPurchase,
        restore:  IAP.onRestore,
        error:    IAP.onError
    });
};

IAP.onReady = function () {
    // Once setup is done, load all product data.
    storekit.load(IAP.list, function (products, invalidIds) {
        console.log('IAPs loading done:');
        for (var j = 0; j < products.length; ++j) {
            var p = products[j];
            console.log('Loaded IAP(' + j + '). title:' + p.title +
                        ' description:' + p.description +
                        ' price:' + p.price +
                        ' id:' + p.id);
            IAP.products[p.id] = p;
        }
        IAP.loaded = true;
        for (var i = 0; i < invalidIds.length; ++i) {
            console.log('Error: could not load ' + invalidIds[i]);
        }
    });
};

IAP.onPurchase = function (transactionId, productId/*, receipt*/) {
	
	var result = 'Purchase data: {"transactionid": "' + transactionId + '", "productId": "' + productId + '"}';
	
	if(typeof result === 'object') {
	    strResult = JSON.stringify(result);
	} else {
	    strResult = result;
	}
	
	var appid 		= $('#applicationid').val();
	var feaid 		= $('#moduleid').val();
	var devctype	= $('#devctype').val();
	var dvcid		= device.uuid;
	
	$.ajax({
		type: "POST",
		url: "<!--SAVERESULTURL--!>",
		data: { appid: appid, modid: feaid, dvctpe: devctype, data: strResult, dvcid: dvcid }
	})
	.done(function(response){
		window.location.reload();
	})
	.error(function(){
		alert('Error: While saving transaction details.');
	})
	
    var n = (localStorage['storekit.' + productId]|0) + 1;
    localStorage['storekit.' + productId] = n;
    if (IAP.purchaseCallback) {
        IAP.purchaseCallback(productId);
        delete IAP.purchaseCallbackl;
    }
};

IAP.onError = function (errorCode, errorMessage) {
    alert('Error: ' + errorMessage);
};

IAP.onRestore = function (transactionId, productId/*, transactionReceipt*/) {
    var n = (localStorage['storekit.' + productId]|0) + 1;
    localStorage['storekit.' + productId] = n;
};

IAP.buy = function (productId, callback) {
    IAP.purchaseCallback = callback;
    storekit.purchase(productId);
};

IAP.restore = function () {
    storekit.restore();
};

IAP.fullVersion = function () {
    return localStorage['storekit.babygooinapp1'];
};

function buyiositem(itemid){
   // alert(itemid);
    IAP.buy(itemid);
}


/***#################### IOS BILLING ##################***/











